/*
 * I/O and buffering
 */

#ifndef __io_h__
#define __io_h__

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif

struct _io {
	int in;
	int out;
	int in_ready;
	int out_ready;
	int eof_in;
	int eof_out;
	size_t buffer_size;
	char *buffer;
	int watermark;
	ssize_t last_read;
	ssize_t last_write;
	unsigned long long total_read;
	unsigned long long total_write;
	unsigned long long total_size;
	int total_size_known;
	unsigned long timeout;
	};

typedef struct _io IO;

extern IO io;

int ioInit(void);
int ioBegin(void);
int ioEnd(void);
void ioCheck(void);
int ioRead(void);
int ioWrite(void);
int ioIsDone(void);

#endif
